/* -*- Mode: C; tab-width: 3; indent-tabs-mode: t; c-basic-offset: 3 -*- */
/*
  decode.c
  heraia - an hexadecimal file editor and analyser based on ghex
 
  (C) Copyright 2005 Olivier Delhomme
  e-mail : heraia@delhomme.org
  URL    : http://heraia.tuxfamily.org
 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or  (at your option) 
  any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY;  without even the implied warranty of
  MERCHANTABILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

#include <gtk/gtk.h>

#include "decode.h"


/*
   general purpose of this function is to take a 4 byte data stream
   and convert it as if it is a dos date. If it is not, the result
   may be funny !
   We do asume that both *data and *result contains correct values
   and has enough space to store any result.
   data : 4 guchars
   result : at least 21 gchars
*/
gint decode_dos_date( guchar *data, gchar *result )
{
  guint16 year, month, day, hour, minutes, seconds;

  if ((data == NULL) || (result == NULL))
    return FALSE;
  else
    {
      year = (data[0] >> 1) + 1980;
      month = ((data[0] & 0x01) << 3) + (data[1] >> 5);
      day = data[1] & 0x1F;
      hour = (data[2] & 0xF8) >> 3;
      minutes = ((data[2] & 0x07) << 3) + ((data[3] & 0xE0) >> 5);
      seconds = (data[3] & 0x1F) << 1;
      sprintf(result, "%02d/%02d/%04d - %02d:%02d:%02d", day, month, year, 
	      hour, minutes, seconds);
      return TRUE;
    }
}
